var lat, longt, loc;

window.onload = function(){
    getLocation();
}

var loadView = function(){
    var token = sessionStorage.getItem("token");
    var div = document.getElementById("container");
    fetch(`https://geocode.xyz/${lat},${longt}?geoit=json`, {
        method: "GET"
    })
    .then(function(response) {
        if (response.status !== 200) {
            console.log(`Looks like there was a problem. Status code: ${response.status}`);
            return;
        } else {
            response.json().then((data) => {
                window.loc = data.city;
            })
        }
    })
    .catch(function(error) {
        console.log("Fetch error: " + error);
    });
    if(token == null){
        var view = document.getElementById("welcome").innerHTML;
        div.innerHTML = view;
    }
    else{
        var view = document.getElementById("profile").innerHTML;
        var connection = new WebSocket('ws://'+ document.domain +':5000/check');
        connection.onopen = function(){
            msg = {
                'token': sessionStorage.getItem('token')
            };
            connection.send(JSON.stringify(msg));
           };
        connection.onmessage = function(e){
            msg = JSON.parse(e.data)['message']
            if(msg == 'Same user logged in.'){
                sessionStorage.removeItem('token');
                loadView();
            }
        };
        div.innerHTML = view;
        showUserInfoByToken(document.getElementsByClassName("tab-item")[0]);
    }
}

var validateSignIn = function(){
    var form = document.getElementById("signIn");
    var pw = form.password;
    if(pw.value.length < 10){
        form.submit.disabled = true;
    }
    else{
        form.submit.disabled = false;
    }

}

var validatePassword = function(form_name){
    var form = document.getElementById(form_name);
    var pw = form.password;
    var rtpPw = form.rpt_password;
    var len = false;
    var same = false;
    var submit = document.getElementById(form_name + "Btn");
    var info = document.getElementById(form_name + "Info");
    if(pw.value.length < 1 || rtpPw.value != pw.value){
        submit.disabled = true;
    }
    else{
        submit.disabled = false;
    }

    if(rtpPw.value == pw.value){
        same = true;
    }

    if(pw.value.length >= 1){
        len = true;
    }
    
    if(!len && !same){
        info.innerHTML = "PW too short & two PWs are not the same!"
    }
    else if(!len){
        if(pw.value.length == 0){
            info.innerHTML = "";
            submit.disabled = false;
        }
        else{
            info.innerHTML = "PW too short!"
        }
    }
    else if(!same){
        info.innerHTML = "Two PWs are not the same!"
    }
    else{
        info.innerHTML = ""
    }
}

var selectTab = function(btn, tabName){
    var panels = document.getElementsByClassName("panel");
    var tabs = document.getElementsByClassName("tab-item");
    for(var i = 0, panel; panel = panels[i]; i++){
        if(panel.id == btn.innerHTML.toLowerCase()){
            panel.style.display = "block";
            tabs[i].className += " active";
        }
        else{  
            tabs[i].className = tabs[i].className.replace(" active", "");
            panel.style.display = "none";
            
        }
    }
}

var initHome = function(div){
    var token = sessionStorage.getItem("token");
    var panel = document.getElementById("home");
    var userInfo = serverstub.getUserDataByToken(token).data;
    var infoDiv = panel.querySelector(".userInfo");
    selectTab(div, "home");
    infoDiv.innerHTML = `<p class='email'>Email: ${userInfo['email']}</p>
                        <p>First name: ${userInfo['firstname']}</p>
                        <p>Family name: ${userInfo['familyname']}</p>
                        <p>Gender: ${userInfo['gender']}</p>
                        <p>City: ${userInfo['city']}</p>
                        <p>Country: ${userInfo['country']}</p>`
    loadWall("home");
}

var loadWall = function(tab){
  if(tab == 'home'){
    showMessageByToken(tab);
  }
  else{
    var email = document.getElementById(tab).getElementsByClassName("email")[0].innerHTML.slice(7);
    showMessageByEmail(email)
  }
}

const lookupFriend = function(e) {
  e.preventDefault();
  const email = document.getElementById("lookup_email").value;
  showMessageByEmail(email);
  showUserInfoByEmail(email);
}

var postMsg = function(form, tab){
    if(form.message.value.length == 0)
      return;
    var email = document.getElementById(tab).getElementsByClassName("email")[0].innerHTML.slice(7);
    createMessage(email, form.message.value, form, tab, window.loc);
}

function allowDrop(ev) {
    ev.preventDefault();
  }
  
  function drag(ev) {
    ev.dataTransfer.setData("text", ev.target.id);
  }
  
  function drop(ev) {
    ev.preventDefault();
    var data = ev.dataTransfer.getData("text");
    var content = document.getElementById(data).innerHTML.split(":");
    ev.target.innerHTML = content[1].slice(1);
  }

  function getLocation() {
    if (navigator.geolocation) {
      navigator.geolocation.getCurrentPosition(showPosition);
    } else { 
      x.innerHTML = "Geolocation is not supported by this browser.";
    }
  }
  
  function showPosition(position) {
    window.lat = position.coords.latitude;
    window.longt = position.coords.longitude;
    loadView();
  }